VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "IPInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'Private Const INADDR_NONE = &HFFFF
'Private Const SOCKET_ERROR = -1
'Private Const WSABASEERR = 10000
'Private Const WSAEINVAL = (WSABASEERR + 22)
'Private Const WSAENETDOWN = (WSABASEERR + 50)
'Private Const WSANOTINITIALISED = (WSABASEERR + 93)
'Private Const WSAHOST_NOT_FOUND = 11001
'Private Const WSADESCRIPTION_LEN = 257
'Private Const WSASYS_STATUS_LEN = 129
'Private Const WSATRY_AGAIN = 11002
'Private Const WSANO_RECOVERY = 11003
'Private Const WSANO_DATA = 11004
'
''-- init errors:
'Private Const WSASYSNOTREADY = (WSABASEERR + 91)
'Private Const WSAVERNOTSUPPORTED = (WSABASEERR + 92)
'Private Const WSAEFAULT = (WSABASEERR + 14)
'Private Const WSAEPROCLIM = (WSABASEERR + 67)
'Private Const WSAEINPROGRESS = (WSABASEERR + 36)
'Private Const WSAEMSGSIZE = WSABASEERR + 40
'
'Private Const AF_INET = 2        '/* internetwork: UDP, TCP, etc. */
'
'Private Type WSAData
'    wVersion       As Integer
'    wHighVersion   As Integer
'    szDescription  As String * WSADESCRIPTION_LEN
'    szSystemStatus As String * WSASYS_STATUS_LEN
'    iMaxSockets    As Integer
'    iMaxUdpDg      As Integer
'    lpVendorInfo   As Long
'End Type
'
'Private Type HOSTENT
'    hName     As Long
'    hAliases  As Long
'    hAddrType As Integer
'    hLength   As Integer
'    hAddrList As Long
'End Type
'
'Private Declare Function WSAStartup Lib "ws2_32.dll" (ByVal wVR As Long, lpWSAD As WSAData) As Long
'Private Declare Function WSACleanup Lib "ws2_32.dll" () As Long
'Private Declare Function GetHostName Lib "ws2_32.dll" Alias "gethostbyaddr" (addr As Long, ByVal addr_len As Long, ByVal addr_type As Long) As Long
'Private Declare Function inet_addr Lib "ws2_32.dll" (ByVal cp As String) As Long
'Private Declare Sub CopyMemory2 Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByVal Source As Long, ByVal Length As Long)

'-- for asynchronous gethost:
'Private Declare Function WSAAsyncGetHostByAddr Lib "ws2_32.dll" (ByVal hWnd As Long, ByVal wMsg As Long, ByRef lngAddr As Long, ByVal lngLenght As Long, ByVal lngType As Long, buf As Any, ByVal lngBufLen As Long) As Long
'Private Declare Function WSACancelAsyncRequest Lib "ws2_32.dll" (ByVal taskhandle As Long) As Long

Private WithEvents IP1 As ipUC '-- ipUC userControl for IP ops.
Attribute IP1.VB_VarHelpID = -1
Private SockOK As Boolean
Private GeoOK As Boolean
Private BooVista As Boolean
Private Geo As GeoIPEx
Private cLoc As Location
Private DBPath As String, FIPSList As String
Private BooBusy As Boolean

  '-- event for script that delivers IP -> Hostname translation async.
Public Event OnHostNameResult(vIP As Variant, vHost As Variant, vErr As Variant)

'------------ Functions: ---------------------------------

' Property TimeOut - number of ms to wait for response. defaults to 5000. max. 60000 (1 minute).

'----------------------------------------

' Function EnableHostNameData()     ' returns 0 if winsock successfully initialized.
'    EnableHostNameData must be called to initialize winsock before calling GetHostNameFromIP.
'  Non-zero error codes from WSAStartup: 1-system not ready for network communication.
' 2 -Winsock version 1.1 not supported. 3-A blocking winsock is already in use.
' 4-The limit on number of winsock tasks has been reached. 5-Unknown error calling WSAStartup function.
' 6-Unknown error.7-Windows Vista.

' Sub GetHostNameFromIP(vIP As Variant)    ' takes IP address string.
'   ASunchronous call that returns its result in the OnHostNameResult event.
'   TimeOut sets how long to wait for return before firing that event with a failure.

' Event OnHostNameResult(IP as variant, Hostname as variant, ErrorCode as variant)
  '-- ErrorCode: 0-success. 1-no winsock initialized. 2-not a valid IP address.
'-- 3-WSAAsyncGetHostByAddr failed. 4-Probably either no host found or no host
'-- name to return for IP. 5-Timed out.

'---------------------------------------

' Function EnableLocationData(vDBPath As Variant) As Variant  ' takes a GeoIPCity.dat
' database path. Returns: 0-success. 1-Unable to load GeoIPEx.dll or os is Vista.
' 2-database path not valid.
'  EnableLocationData must be called before calling GetLocationFromIP.

' Function GetLocationFromIP(vIP as variant) As Location  ' takes an IP string.
'  Returns a Location object that provides access to location info.
'  Location.Valid returns False if no location info. was available.

'- Location object: Country, CountryCode, Region, City, ZipCode, AreaCode, Valid

'--------------------------------------

    '-- set timeout value in ModAsync.
Public Property Let TimeOut(vTime As Variant)
  Dim LTime As Long
 On Error Resume Next
    If IsNumeric(vTime) Then
      LTime = CLng(vTime) '-- safety measure in case more than 65,000 is set.
      If (LTime > 60000) Then LTime = 60000
      IP1.TimeOutUC = CInt(LTime)
    End If
End Property

 '-- used to keep script rnning while it waits for hostname event.
Public Property Get Busy() As Variant
  Busy = CVar(BooBusy)
End Property

    '-- initialize winsock before proceeding with getting host names.
Public Function EnableHostNameData() As Variant
  Dim LRet As Long
  Dim WData As WSAData  'structure to pass to WSAStartup as an argument
     On Error Resume Next
     
    If (BooVista = True) Then
       EnableHostNameData = CVar(7)
       Exit Function
    End If
    
    If (SockOK = True) Then
       EnableHostNameData = CVar(0)
       Exit Function
    End If
    
   LRet = IP1.StartUp()
     If (LRet = 0) Then SockOK = True
   EnableHostNameData = CVar(LRet)
End Function

  '-- send in ip address. result is returned in ipUC.IPResolved event.
Public Sub GetHostNameFromIP(vIP As Variant)
  Dim sIP As String
        On Error Resume Next
     sIP = CStr(vIP)
     BooBusy = True
     IP1.GetHostNameA sIP
End Sub

Public Function EnableLocationData(vDBPath As Variant) As Variant
 Dim sPath As String, sFil As String, sFol As String
 Dim Pt1 As Long
 Dim Boo1 As Boolean
  On Error Resume Next
    GeoOK = False
    EnableLocationData = CVar(1)  '-- failed to load DLL. probably not registered.
    If (BooVista = True) Then Exit Function
    
    Set Geo = New GeoIPEx
      If (Err.Number <> 0) Then Exit Function
   
    EnableLocationData = CVar(2)  '-- database path invalid.
    sPath = CStr(vDBPath)
      If jsFileExists(sPath) = False Then Exit Function
    Pt1 = InStrRev(sPath, "\")
    sFil = Right$(sPath, (Len(sPath) - Pt1))
      If (UCase$(sFil) <> "GEOIPCITY.DAT") Then Exit Function
    DBPath = Left$(sPath, Pt1)  '-- parent folder path\  of GeoIPCity.dat file.
    
     '-- Tell the GeoLite lib. the path to database.
    Boo1 = Geo.set_db_path(DBPath)
     '-- load the region translation list.
    FIPSList = StrConv(LoadResData("FIPSLIST", "CUSTOM"), vbUnicode)
    GeoOK = True
    EnableLocationData = 0
End Function

Public Function GetLocationFromIP(vIP As Variant) As Location
  Dim sIP As String
  Dim Boo1 As Boolean
  Dim LI1 As LocInfo
      On Error Resume Next
  
  '-- Starts with blank LocInfo UDT. If there's a problem just go to the end,
  '-- which will result in passing an empty Location object to caller.
    If (GeoOK = False) Then GoTo Finish
  sIP = CStr(vIP)
  Boo1 = Geo.find_by_addr(sIP)
    If (Boo1 = False) Then GoTo Finish
       
     With LI1
       .Country1 = Geo.country_name
       .CountryCode1 = Geo.country_code
       .Region1 = GetRegionName(Geo.country_code, Geo.Region)
       .City1 = Geo.City
        If .CountryCode1 = "US" Or .CountryCode1 = "CA" Then
          .ZipCode1 = Geo.postal_code
        End If
       .AreaCode1 = Geo.area_code
       .Valid1 = True
     End With
            
Finish:
    '-- sets this LocInfo as internal LocInfo in Location class, which takes care
    '-- of setting all Location object properties at once.
  cLoc.Reset LI1
  Set GetLocationFromIP = cLoc
End Function


'---88888888888888888888888888 private ops 888888888888888888888888
'------------------------------------------------------------------

  '-- send in country code and region code. Get back region name.
  '-- This checks FIPSLIST for region translation. FIPLIST is just a
  '-- text file saved as an internal resource. Format is just:
  '-- FR,09,Normandy*FR,10,Champagne*  etc.
Private Function GetRegionName(sC2 As String, sR2 As String) As String
  Dim Pt1 As Long, Pt2 As Long
  Dim sCode As String
      On Error Resume Next
        '-- If this is Canada or the US then region name is already set.
   If (sC2 = "US") Or (sC2 = "CA") Then GetRegionName = sR2: Exit Function
        '-- if country code or region numeric code are absent then quit.
   If (Len(sC2) = 0) Or (Len(sR2) = 0) Then GetRegionName = "": Exit Function
   sCode = sC2 & "," & sR2  '-- Ex.: FR,09
    Pt1 = InStr(1, FIPSList, sCode, 0)
     If (Pt1 = 0) Then GetRegionName = "": Exit Function
    Pt2 = InStr(Pt1, FIPSList, "*", 0)
    Pt1 = InStrRev(FIPSList, ",", Pt2, 0)
   GetRegionName = Mid$(FIPSList, (Pt1 + 1), (Pt2 - (Pt1 + 1)))
End Function

Private Sub Class_Initialize()
  Dim CV As CVista
    On Error Resume Next
      SockOK = False
      GeoOK = False
    Set CV = New CVista
     BooVista = CV.IsVista()
    Set CV = Nothing
  If (BooVista = True) Then
     MsgBox "Windows Vista is not supported.", 64, "IPInfo"
     Exit Sub
  End If
   Set cLoc = New Location '-- create one Location object to use for passing to function.
   Load F2                 '-- cLoc will be refreshed with each use.
   Set IP1 = F2.ipUC1
   Hook F2.hwnd
End Sub

Private Sub Class_Terminate()
    On Error Resume Next
   If (BooVista = True) Then Exit Sub
  Set Geo = Nothing
  Set cLoc = Nothing
  Set IP1 = Nothing
  F2.ipUC1.CloseDown
  Unhook F2.hwnd
  Unload F2
  Set F2 = Nothing
End Sub
  
    '-- A request is sent via IPInfo.GetHostNameFromIP,
    '-- which calls GetHostNameA in the ipUC. Those are both
    '-- subs. The UC then calls WSAAsyncGetHostByAddr and sets the
    '-- timer. If the result returns before the timer finishes then
    '-- the UC fires IPResolved and sends back host name. Otherwise,
    '-- the timer in the UC fires IPResolved, returning "" for host name.
    '-- That fire here, and the class then fires a public event to
   '-- make it available.
Private Sub IP1_IPResolved(sIP As String, sHost As String, LErr As Long)
    On Error Resume Next
  RaiseEvent OnHostNameResult(CVar(sIP), CVar(sHost), CVar(LErr))
  BooBusy = False
End Sub
